#version 330

in vec2 texCoord;
in vec3 worldNormal;
in vec3 pos;

uniform sampler2D color_texture;
uniform vec4 vColor;

layout(location=0) out vec4 fragColor;

uniform vec3 vColorLight;
uniform vec3 vDirection;
uniform float fAmbientIntensity;

void main()
{
	
	vec4 vTexColor = texture2D(color_texture, texCoord);
	float fDiffuseIntensity = max(0.0, dot(normalize(pos), -normalize(vDirection)));
	fragColor = vTexColor*vColor*vec4(vColorLight*(fAmbientIntensity+fDiffuseIntensity), 1.0);

	// test
	//fragColor = vTexColor*vec4(1.0f, 1.0f, 1.0f, 1.0f)*vec4(vec3(1.0f, 1.0f, 1.0f)*(0.25f+fDiffuseIntensity), 1.0);
}