#version 330 core

in vec3 position;
in vec3 normal;
in vec2 uv;

out vec3 worldNormal;
out vec2 texCoord;
out vec3 pos;

uniform mat4 model;
uniform mat4 view_proj;

void main() 
{
	
	texCoord = uv;
	pos = (model * vec4(position, 1)).xyz;
	gl_Position = view_proj * model * vec4(position,1);
	worldNormal = (model * vec4(position, 1)).xyz;
}