#version 330

uniform mat4 modelMatrix;
uniform mat4 viewMatrix;
uniform mat4 projectionMatrix;
uniform mat4 DepthBiasMVP; 

in vec3 position;
in vec3 normals;
in vec2 uv;

out vec2 UVs;
out vec3 position_worldspace;
out vec3 normal_cameraspace;
out vec3 eyeDirection_cameraspace;
out vec3 lightDirection_cameraspace;
out vec4 ShadowCoord; 


void main()
{
	

	vec3 lightPosition_worldspace = vec3(0.0, 5.0, -11.4255); 
	gl_Position = projectionMatrix * viewMatrix * modelMatrix * vec4(position, 1);
	position_worldspace = (modelMatrix * vec4(position,1)).xyz;
	normal_cameraspace = (viewMatrix * modelMatrix * vec4(normals, 0)).xyz;
	vec3 position_cameraspace = ( viewMatrix * modelMatrix * vec4(position,1)).xyz;
	eyeDirection_cameraspace = vec3(0,0,0) - position_cameraspace;
	vec3 LightPosition_cameraspace = ( viewMatrix * vec4(lightPosition_worldspace,1)).xyz;
	lightDirection_cameraspace = LightPosition_cameraspace + eyeDirection_cameraspace;
	UVs = uv;
	ShadowCoord = DepthBiasMVP * vec4(position,1);
}